/*
 * sampleServer.C:
 *    This server implements the RPC interface in sample.idl. The CallMe
 * function doesn't really do anything. 
 *
 * sampleServer.C,v 1.4 1993/03/31 17:39:26 gjb Exp
 */

#include <objdce/statics.H>
#include <iostream.h>
#include <objdce/nontranserver.H>
#include <objdce/binding.H>
#include <objdce/error.H>
#include <sample.h>
#include <String.h>

error_status_t CallMe(handle_t, long argument)

{
  /* Here, we just multiply the argument by 2.*/
  argument *= 2;
  cout << "CallMe was called." << endl;
  return 0;
}

static void PrintUsage()

{
  cerr << "Usage: testServer <server name>" << endl;
  cerr << "       testServer -wk <endpoint>" << endl;
}

main(int argc, char** argv)

{
  SetObjtranErrorLevel(DebugMsg);
  if ((argc < 2) || (argc > 3))
    {
      PrintUsage();
      return -1;
    }
  String serverName = argv[1];
  NonTranServer* server;
  if ((argc == 3) && !strcmp(argv[1], "-wk"))
  {
    int endpoint = atoi(argv[2]);
    server = new NonTranServer(RPCServer(Sample,1,0), endpoint, 
                               UDP, (ServerLoginContext*)0);
    cout << "Registered server at endpoint " << endpoint;
    cout << " and listening..." << endl;
  }
  else if (argc == 2)
  {
    server = new NonTranServer(RPCServer(Sample,1,0), serverName,
			       "Sample DCE server", UDP, 
			       (ServerLoginContext*)0);
    cout << "Registered server at " << serverName;
    cout << " and listening for RPC calls..." << endl;
  }
  server->StartServer();
  cout << "Server terminating..." << endl;
  delete server;
  return 0;
}
