/*
 * sampleClient.C:
 *    This simple program looks up our sample binding and calls "CallMe"
 * once. It takes one argument -- the name with which the server registered
 * itself with CDS.
 *
 * wkClient.C,v 1.2 1993/01/14 22:36:33 gjb Exp
 */

#include <objdce/statics.H>	/* Necessary for SunOS bug workaround */
#include <string.h>
#include <stdlib.h>
#include <iostream.h>
#include <objdce/binding.H>
#include <sample.h>
extern "C"
{
#include <dce/rpc.h>
#include <dce/dce_error.h>
}

static void PrintUsage()

{
  cout << "Usage: wkClient [host] [port] <-shutdown>" << endl;
}

main(int argc, char** argv)
{
  unsigned char errorString[dce_c_error_string_len];
  error_status_t rpcError;
  int errorError;
  Binding* svrBinding;
  Boolean shutItDown = false;

  if ((argc < 3) || (argc > 4) ||
      ((argc == 4) && (strcmp(argv[3], "-shutdown"))))
    {
      PrintUsage();
      return -1;
    }
  if (argc == 4)
    shutItDown = true;
  int port = atoi(argv[2]);
  svrBinding = new Binding(argv[1], port, (LoginContext*)0);
  if (svrBinding->IsValid())
  {
    if (!shutItDown)
      {
	const String& strBinding = *svrBinding;
        cout << "Established binding to port ";
	cout << (const char*)strBinding << endl;
	cout << "Calling server RPC..." << endl;
        rpcError = CallMe(*svrBinding, 1);
        if (rpcError != error_status_ok)
        {
          dce_error_inq_text(rpcError, errorString, &errorError);
          cerr << "Error calling CallMe: ";
          cerr << errorString << endl;
        }
        else
          cout << "Call successful." << endl;
      }
    else
      {
        cout << "Shutting down server..." << endl;
        svrBinding->StopServerListening();
      }
  }
  else
    cerr << "Binding lookup failed." << endl;
  delete svrBinding;
  return 0;
}
