/*
 * DBMDatabase
 *
 *    This class abstracts the ndbm(3) library, which comes with most decent
 * Unixes.
 *
 * dbmdatabase.H,v 1.1 1993/11/27 01:38:52 gjb Exp
 */

#ifndef DBM_DATABASE_H
#define DBM_DATABASE_H

#include <String.h>
#include <objdce/mutex.H>
#include <ndbm.h>
#include <dbmdatum.H>

extern const int DBM_SUCCESS;
extern const int DBM_ENTRY_NOT_FOUND;
extern const int DBM_DUPLICATE_ENTRY;
extern const int DBM_INTERNAL_ERROR;
extern const int DBM_FILE_NOT_OPEN;
extern const int DBM_END_OF_RANGE;

class DBMDatabase

{
public:
  DBMDatabase(const String& fileName);
  virtual ~DBMDatabase();
  int Fetch(const DBMDatum& key, DBMDatum& out);
  int Insert(const DBMDatum& key, const DBMDatum& data);
  int Replace(const DBMDatum& key, const DBMDatum& data);
  int Delete(const DBMDatum& key);
  int FirstKey(DBMDatum& out);
  int NextKey(DBMDatum& out);
private:
  int DoStore(const DBMDatum& key, const DBMDatum& data, int flags);
  int CheckOpen() const;
  DBM* database;
  MutexLock latch;
};

#endif
