/*
 * DBMDatum
 *
 *    This is a single datum for DBM.
 *
 * dbmdatum.C,v 1.1 1993/11/27 01:38:54 gjb Exp
 */

#include <stdlib.h>
#include <dbmdatum.H>

DBMDatum::DBMDatum()

{
  data.dptr = (char*)0;
  data.dsize = 0;
  allocSize = 0;
}

DBMDatum::DBMDatum(const DBMDatum& d)

{
  allocSize = 0;
  this->operator = (d);
}

DBMDatum::DBMDatum(const String& s)

{
  allocSize = 0;
  this->operator = (s);
}

DBMDatum::DBMDatum(const datum d)

{
  allocSize = 0;
  Assign(d.dptr, d.dsize);
}

DBMDatum::DBMDatum(const char* data, const int length)

{
  allocSize = 0;
  Assign(data, length);
}

DBMDatum::~DBMDatum()

{
  if (allocSize > 0)
    {
      free((char*)data.dptr);
    }
}

DBMDatum& DBMDatum::operator = (const DBMDatum& d)

{
  Assign(d.data.dptr, d.data.dsize);
  return *this;
}

DBMDatum& DBMDatum::operator = (const String& s)

{
  Assign(s, s.length() + 1);
  return *this;
}

DBMDatum& DBMDatum::operator = (const datum d)

{
  Assign(d.dptr, d.dsize);
  return *this;
}

void DBMDatum::Assign(const String& newData)

{
  Assign(newData, newData.length() + 1);
}

void DBMDatum::Assign(const char* newData,
		      const int newDataLength)
{
  if (allocSize < newDataLength)
    {
      if (data.dptr == (char*)0)
	{
	  data.dptr = (char*)malloc(newDataLength);
	}
      else
	{
	  data.dptr = (char*)realloc((char*)data.dptr, newDataLength);
	}
      allocSize = newDataLength;
    }
  if (data.dptr == (char*)0)
    {
      allocSize = data.dsize = 0;
    }
  else
    {
      data.dsize = newDataLength;
      memcpy(data.dptr, newData, newDataLength);
    }
}

int DBMDatum::operator == (const DBMDatum& d) const

{
  if (data.dsize > d.data.dsize)
    {
      return 1;
    }
  else if (data.dsize < d.data.dsize)
    {
      return -1;
    }
  else
    {
      return memcmp(data.dptr, d.data.dptr, data.dsize);
    }
}

  
