/*
 * DBMDatum
 *
 *    This represents a single data item (datum) in a DBM database. A datum
 * can be either a key or data.	
 *
 * dbmdatum.H,v 1.1 1993/11/27 01:38:55 gjb Exp
 */

#ifndef DBM_DATUM_H
#define DBM_DATUM_H

#include <String.h>
#include <ndbm.h>

class DBMDatum

{
public:
  DBMDatum();
  DBMDatum(const DBMDatum&);
  DBMDatum(const String& data);
  DBMDatum(const char* data, const int length);
  DBMDatum(const datum);
  ~DBMDatum();
  DBMDatum& operator = (const DBMDatum&);
  DBMDatum& operator = (const String& newData);
  DBMDatum& operator = (const datum);
  operator datum() const;
  void Assign(const String& newData);
  void Assign(const char* newData, const int newDataLength);
  int operator == (const DBMDatum&) const;
  const String GetStringData() const;
  const char* GetData() const;
  const int GetDataLength() const;
private:
  datum data;
  int allocSize;
};

inline const String DBMDatum::GetStringData() const

{ return String(data.dptr); }

inline const char* DBMDatum::GetData() const

{ return data.dptr; }

inline const int DBMDatum::GetDataLength() const

{ return data.dsize; }

inline DBMDatum::operator datum() const

{ return data; }

#endif
