/*
 * phonebooktest
 *
 *    This is a client-only (for now) phone book test application.
 *
 * phonebooktest.C,v 1.2 1994/03/17 18:40:32 gjb Exp
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <phonebook.H>
#include <objdce/statics.H>

static const int InputBufLen = 1024;

void FillInEntry(PhoneBookEntry& out)

{
  char input[InputBufLen];

  printf("Name: ");
  gets(input);
  out.Name(input);
  printf("Organization: ");
  gets(input);
  out.Organization(input);
  printf("Number: ");
  gets(input);
  out.Number(input);
  printf("Address: ");
  gets(input);
  out.Address(input);
  printf("Comments: ");
  gets(input);
  out.Comments(input);
}

void FillInID(PhoneBookEntryID& id)

{
  char input[InputBufLen];

  printf("ID: ");
  gets(input);
  id = atol(input);
}

void PrintOutEntry(const PhoneBookEntry& entry)

{
  printf("ID: %lu\n", entry.ID());
  printf("Name: %s\n", (const char*)(entry.Name()));
  printf("Organization: %s\n", (const char*)(entry.Organization()));
  printf("Number: %s\n", (const char*)(entry.Number()));
  printf("Address: %s\n", (const char*)(entry.Address()));
  printf("Comments: %s\n", (const char*)(entry.Comments()));
}

void LoopCommands(PhoneBook& theBook)

{
  char input[InputBufLen];
  char command = '\0';
  PhoneBookEntry entry;
  List<PhoneBookEntry> entryList;
  Listiter<PhoneBookEntry> entryListIter(entryList);
  PhoneBookEntryID entryID;
  String key;

  while (command != 'q')
    {
      entry.Initialize();
      printf("[<I>nsert <R>eplace <F>ind <G>et <D>elete <L>ist <Q>uit] ");
      gets(input);
      command = input[0];
      tolower(command);
      switch(command)
	{
	case 'i':
	  FillInEntry(entry);
	  theBook.Insert(entry);
	  break;
	case 'r':
	  FillInID(entryID);
	  FillInEntry(entry);
	  theBook.Replace(entryID, entry);
	  break;
	case 'f':
	  printf("Name: ");
	  gets(input);
	  key = input;
	  theBook.Find(key, entryList);
	  entryListIter.reset();
	  while (entryListIter.next(entry))
	    PrintOutEntry(entry);
	  break;
	case 'g':
	  FillInID(entryID);
	  theBook.Get(entryID, entry);
	  PrintOutEntry(entry);
	  break;
	case 'd':
	  FillInID(entryID);
	  theBook.Delete(entryID);
	  break;
	case 'l':
	  theBook.GetAll(entryList);
	  entryListIter.reset();
	  while (entryListIter.next(entry))
	    PrintOutEntry(entry);
	  break;
	case 'q':
	  break;
	default:
	  printf("Invalid command\n");
	  break;
	}
    }
}

static void PrintUsage(char* execName)

{
  printf("Usage: %s <database name>\n", execName);
}

int main(int argc, char** argv)

{
  String dbName;
 
  ObjtranFirstInit();
  if (argc != 2)
    {
      PrintUsage(argv[0]);
      return 1;
    }
  dbName = argv[1];
  PhoneBook theBook(dbName);
  LoopCommands(theBook);
  return 0;
}
