/*
 * phonelookup
 *
 *    This is a really simple server that looks up a phone number from one,
 * and only one, phone book server.
 *
 * phonelookup.C,v 1.1 1993/11/27 01:39:21 gjb Exp
 */

#include <objdce/statics.H>
#include <iostream.h>
#include <phoneclient.H>
#include <phoneglobals.H>

static void PrintUsage(char* execName)

{
  cerr << "Usage: " << execName << " <search key> [server name]" << endl;
  cerr << "Examples: " << execName << " joe /.:/servers/phone" << endl;
  cerr << "          " << execName << " \"Fred Smith\"" << endl;
  cerr << endl;
  cerr << "If [server name] is not set, the environment variable" << endl;
  cerr << "\"" << EnvironmentServerName << "\" is consulted" << endl;
}

int main (int argc, char** argv)

{
  if ((argc < 2) || (argc > 3))
    {
      PrintUsage(argv[0]);
      return 1;
    }
  String key = argv[1];
  String serverName;

  if (argc == 3)
    {
      serverName = argv[2];
    }
  else
    {
      char* sName = getenv(EnvironmentServerName);
      if (sName == (char*)0)
	{
	  cerr << "The DCE name of a phone book server must be specified" << endl;
	  cerr << "the command line, or the environment variable \"";
	  cerr << EnvironmentServerName << "\" must be set." << endl;
	  return 1;
	}
      serverName = sName;
    }
  
  PhoneClient pClient;
  if (!pClient.Working())
    {
      return 1;
    }

  List<PhoneBookEntry> results;
  PhoneBookEntry oneResult;

  pClient.Find(serverName, key, results);
  if (results.length() > 0)
    {
      Listiter<PhoneBookEntry> resultIter(results);
      while (resultIter.remove_next(oneResult))
	{
	  cout << oneResult;
	}
    }
  else
    {
      cout << "No matching entries found." << endl;
    }
  return 0;
}



