/*
 * phoneservermain.C
 *
 *    This is the main program for the phone server application.
 *
 * phoneservermain.C,v 1.1 1993/11/27 01:39:32 gjb Exp
 */

#include <objdce/statics.H>
#include <objdce/nontranserver.H>
#include <objdce/login.H>
#include <phonebook.H>
#include <phoneglobals.H>
#include <phoneserver.h>

static void PrintUsage(char* execName)

{
  printf("Usage: %s <database name> <DCE name> <principal> <keytable>\n",
	 execName);
}

int main(int argc, char** argv)

{
  ServerLoginContext* context;
  String dbName;
  String dceName;
  String prinName;
  String keytableName;

  if (argc != 5)
    {
      PrintUsage(argv[0]);
      return 1;
    }
  dbName = argv[1];
  dceName = argv[2];
  prinName = argv[3];
  keytableName = argv[4];

  context = new ServerLoginContext();
  if (context->LogIn(prinName, keytableName, 
		     "", DefaultProtLevel,
  		     LoginContext::AUTO_REFRESH) != LoginContext::SUCCESS)
    {
      delete context;
      printf("Couldn't establish login context. Exiting.\n");
      return 2;
    }
  
  TheBook = new PhoneBook(dbName);
  TheServer = new NonTranServer(RPCServer(PhoneServer,1,0), 
				dceName, ServerAnnotation, 
				DefaultRPCProtocol, context);
  printf("Server is ready at %s\n", (const char*)dceName);
  fflush(stdout);
  TheServer->StartServer(DefaultRPCThreads);
      
  printf("Server is shutting down.\n");
  fflush(stdout);
  delete TheServer;
  delete TheBook;
  delete context;
  return 0;
}
