/* 
 * tranServer.C
 *    This is a transactional RPC server that just exports one function.
 *
 * tServer.C,v 1.3 1993/03/31 17:40:07 gjb Exp
 */

#include <objdce/statics.H>
#include <iostream.h>
#include <stdio.h>
#include <unistd.h>
#include <objdce/error.H>
#include <objdce/erroutput.H>
#include <objtran/transerver.H>
#include <objtran/transaction.H>
#include <objtran/recoverable.H>
extern "C"
{
#include <tran.h>
}

void CallMeTransactionally(trpc_handle_t, long argument)

{
  FunctionName("CallMeTransactionally");
  ExistingTransaction tran;

  /* If "argument" is odd, we abort. Otherwise we don't. */
  if ((argument % 2) != 0)
      tran.Abort("Odd numbers are evil", 666, 1);
  if (tran.Aborted())
    cout << "We aborted the transaction" << endl;
  else
    cout << "CallMeTransactionally completed properly" << endl;
}

static void PrintUsage()

{
  cerr << "Usage: tranServer <server name>" << endl;
  cerr << "       tranServer -wk <endpoint>" << endl;
} 

main (int argc, char** argv)

{
  FunctionName("main");
  TranServer* server;
//  SetObjtranErrorLevel(DebugMsg);
  if ((argc < 2) || (argc > 3))
    {
      PrintUsage();
      return -1;
    }
  FakeRecoverable faker;
  List_of_p<TranComponent> components(&faker);
  if ((argc == 3) && !strcmp(argv[1], "-wk"))
  {						// Use well-known-endpoints
    long endpoint = atol(argv[2]);
    server = new TranServer(RPCServer(TranSample,1,0), 
			    RPCVector(TranSample,1,0), (ServerLoginContext*)0,
			    endpoint, &components);
    cout << "Registered server at endpoint " << endpoint;
    cout << " and listening..." << endl;
  }
  else if (argc == 2) 
  {
    server = new TranServer(RPCServer(TranSample,1,0), RPCVector(TranSample,1,0),
			    argv[1], "sample TRPC server", UDP, 
			    (ServerLoginContext*)0, &components);
    cout << "Registered server at " << argv[1] << " and listening..." << endl;
  }
  else
  {
    PrintUsage();
    return -1;
  }
  server->StartServer();
  cout << "Server exiting..." << endl;
  delete server;
  return 0;
}
