/*
 * tranClient.C:
 *    This is a very simple sample client that talks to our sample TRPC
 * server. Since neither member of our sample transaction is recoverable,
 * the transaction will abort every time.
 *
 * wkClient.C,v 1.2 1993/01/14 22:36:51 gjb Exp
 */

#include <objdce/statics.H>
#include <string.h>
#include <stdio.h>
#include <iostream.h>
#include <objtran/tranbinding.H>
#include <objtran/transaction.H>
#include <objdce/abortreason.H>
#include <objtran/tranclient.H>
#include <objdce/error.H>
extern "C"
{
#include <tran.h>
}

static void PrintUsage()

{
  cerr << "Usage: testClient <host> <port #> [-shutdown]" << endl;
}

main(int argc, char** argv)

{
  TranBinding* svrBinding;
  TranClient* client;
  Boolean shutItDown = false;
  long inc;

  if ((argc < 3) || (argc > 4) ||
      ((argc == 4) && (strcmp(argv[3], "-shutdown"))))
    {
      PrintUsage();
      return -1;
    }
  if (argc == 4)
    shutItDown = true;
  client = new TranClient();
  long port = atol(argv[2]);
  svrBinding = new TranBinding(argv[1], port, (LoginContext*)0);
  if (svrBinding->IsValid())
  {
    if (!shutItDown)
      {
        const String& strBinding = *svrBinding;
        cout << "Established binding to server at " << strBinding;
        cout << endl;
        for (inc = 1; inc < 5; inc++)
          {
            cout << "Calling server TRPC..." << endl;
            NewTransaction* tran = new NewTransaction(5);
            CallMeTransactionally(*svrBinding, inc);
            tran->Commit();
            if (tran->Aborted())
              {
                String errStr;
                tran->GetAbortReason()->Print(errStr);
                cerr << "Call failed: " << errStr << endl;
              }
            else
              cout << "Call successful." << endl;
            delete tran;
          }
      }
    else
      {
        cout << "Shutting down server..." << endl;
        svrBinding->StopServerListening();
      }
  }	
  else
    cerr << "Binding lookup failed" << endl;
  delete svrBinding;
  delete client;
  return 0;
}
