/*
 * sampleClient.C:
 *    This simple program looks up our sample binding and calls "CallMe"
 * once. It takes one argument -- the name with which the server registered
 * itself with CDS.
 *
 * sampleClient.C,v 1.1 1993/03/31 17:41:05 gjb Exp
 */

#include <objdce/statics.H>	/* Necessary for SunOS bug workaround */
#include <string.h>
#include <iostream.h>
#include <objdce/binding.H>
#include <objdce/bindinggroup.H>
#include <sample.h>
extern "C"
{
#include <dce/rpc.h>
#include <dce/dce_error.h>
}

main(int argc, char** argv)
{
  unsigned char errorString[dce_c_error_string_len];
  error_status_t rpcError;
  int errorError;
  Binding* svrBinding;
  Boolean shutItDown = false;
  int curServer;

  if ((argc < 2) || (argc > 3) ||
      ((argc == 3) && (strcmp(argv[2], "-shutdown"))))
    {
      cerr << "Usage: testClient <group name> [-shutdown]" << endl;
      return -1;
    }
  if (argc == 3)
    shutItDown = true;
  svrBinding = new Binding(argv[1], RPCClient(Sample,1,0), 
		(LoginContext*)0);
  if (!shutItDown)
    {
      curServer = 0;
      while (svrBinding->IsValid())
	{
	  const String& strBinding = *svrBinding;
	  cout << "Established binding to port " << strBinding << endl;
	  cout << "Calling server RPC..." << endl;
	  rpcError = CallMe(*svrBinding, curServer);
	  if (rpcError != error_status_ok)
	    {
	      dce_error_inq_text(rpcError, errorString, &errorError);
	      cerr << "Error calling CallMe: ";
	      cerr << errorString << endl;
	    }
	  else
	    cout << "Call successful." << endl;
	  curServer++;
	  svrBinding->RebindNewHost();
	}
      cout << "Done." << endl;
    }
  else
    {
      cout << "Shutting down server..." << endl;
      svrBinding->StopServerListening();
    }
  delete svrBinding;
  return 0;
}
