/*
 * sampleServer.C:
 *    This server implements the RPC interface in sample.idl. The CallMe
 * function doesn't really do anything. 
 *
 * sampleServer.C,v 1.1 1993/05/06 22:40:35 gjb Exp
 */

#include <objdce/statics.H>
#include <iostream.h>
#include <objdce/nontranserver.H>
#include <objdce/binding.H>
#include <objdce/bindinggroup.H>
#include <objdce/error.H>
#include <sample.h>
#include <String.h>

static int myNumber;

error_status_t CallMe(handle_t, long argument)

{
  cout << "Server " << myNumber << " called with argument ";
  cout << argument << endl;
  return 0;
}

static void PrintUsage()

{
  cerr << "Usage: testServer <group name> <server name> <number>" << endl;
}

main(int argc, char** argv)

{
  NonTranServer* server;
  BindingGroup* group;

  if (argc != 4)
    {
      PrintUsage();
      return -1;
    }
  String groupName = argv[1];
  String serverName = argv[2];
  myNumber = atoi(argv[3]);
  server = new NonTranServer(RPCServer(Sample,1,0), serverName,
			     "Sample DCE server", UDP, (ServerLoginContext*)0);
  cout << "Registered server " << myNumber << " at " << serverName << endl;
  group = new BindingGroup(groupName);
  group->Add(serverName);
  cout << "Added server to group " << groupName << endl;
  cout << "Listening for RPC calls..." << endl;
  server->StartServer();
  cout << "Server terminating..." << endl;
  group->Remove(serverName);
  delete group;
  delete server;
  return 0;
}
