/*
 * tranClient.C:
 *    This is a very simple sample client that talks to our sample TRPC
 * server. Since neither member of our sample transaction is recoverable,
 * the transaction will abort every time.
 *
 * tClient.C,v 1.2 1994/03/17 18:41:03 gjb Exp
 */

#include <objdce/statics.H>
#include <string.h>
#include <stdio.h>
#include <iostream.h>
#include <monobjtran/monclient.H>
#include <objtran/transaction.H>
#include <objdce/abortreason.H>
#include <objdce/error.H>
extern "C"
{
#include <tran.h>
}

static void PrintUsage()

{
  cerr << "Usage: testClient" << endl;
}

main(int argc, char** argv)

{
  MonClient* client;
  long inc;
  char* abortStr;

  if (argc != 1)
    {
      PrintUsage();
      return -1;
    }
  client = new MonClient("Objtran example 9", LoginContext::NONE);

  cout << "Calling server TRPC..." << endl;
  for (inc = 0; inc < 8; inc++)
  {
    NewTransaction* tran = new NewTransaction();
    CallMeTransactionally(inc);
//    CallMeTransactionally(2);
    tran->Commit();
    if (tran->Aborted())
      {
        String errStr;
        tran->GetAbortReason()->Print(errStr);
        cerr << "AbortReason says: " << errStr << endl;
      }
    else
      cout << "Call successful." << endl;
    delete tran;
  }
  
  delete client;
  return 0;
}
