#include<monobjtran/monerror.H>
#include<objtran/rpctrancheckstatus.H>
#include <iostream.h>


extern "C"
{
#include<tpm/mon/mon_client.h>
}

FILE * ptr;
static const unsigned int MaxHostNameLength = 128;
static const unsigned int MaxDateLength = 48;
static const unsigned int MaxPidLength = 16;
static const unsigned int LevelLength = 4;
static const unsigned int MaxProcNameLength = 64;
static const unsigned int MaxHostPidLength =
MaxHostNameLength + MaxPidLength + MaxProcNameLength;

static const unsigned int OutBufferLength =
        MaxHostPidLength + MaxDateLength + LevelLength;

Boolean CheckLevelMon(ErrorLevels::ReportingLevels curLevel, ErrorLevels::ReportingLevels dLevel)

{
   unsigned long diagLevel;

   mon_ReportLevel(& diagLevel);
   int lvl;
   switch (curLevel)
    {
      case 0:
        lvl = 65;
        break; 
      case 1:
        lvl = 45;
        break;
      case 2:
      case 3:
        lvl = 25;
        break;
      case 4:
      case 5:
	lvl = 5;
        break;	
    default:
      cout<<"Illigal error number"<<endl;
      fprintf(stderr," Illigal value of the curLevel\n");
      break;

    }
   return (diagLevel >= lvl);
 }
       

MonOutput::MonOutput()
{
 class_num = 13;
}

MonOutput::MonOutput(long cl_num)
{
 class_num = cl_num;
}

void MonOutput::Output(const String& s, 
		       ErrorLevels::ReportingLevels level)
{
  char buffer[OutBufferLength];
  
  FormatOutput(level, buffer, OutBufferLength);
  strcat(buffer, s);
  mon_status_t ret_mon;	
  int size;
  size = strlen(buffer);

  int lvl;

   switch (level)
    {
      case 0:
        lvl = 65;
        break;
      case 1:
        lvl = 45;
        break;
      case 2:
      case 3:
        lvl = 25;
        break;
      case 4:
      case 5:
        lvl = 5;
        break;
    default:
      cout<<"Illigal error number"<<endl;
      fprintf(stderr," Illigal value of the curLevel\n");
      break;

    }

  if(CheckLevelMon(level,level))
    {
    // fprintf(stderr,"/n sizeTotal = %ul \n",size);
      ret_mon = mon_ReportApplData((unsigned long)lvl, class_num, 
				   (void*)buffer, (unsigned long)size);
/*      fprintf(stderr,"ret_mon STRING:   ");
      char statusBuf[ENCINA_MAX_STATUS_STRING_SIZE];
      statusBuf[0] = '\0';
      encina_StatusToString(ret_mon, ENCINA_MAX_STATUS_STRING_SIZE, statusBuf);
      fprintf(stderr," %s \n", statusBuf);*/

      if(ret_mon == MON_SUCCESS)
	{
	  ret_mon = mon_ReportForce(MON_CONTINUE);
	}
    }
}

void MonOutput::Output(const void*, const long length)
{
  fprintf(stderr, "Tried to write %li bytes of untyped data to stderr.\n",
          length);
}
