/*
 * monmain
 *    This is the main for a monitor application. Users can't write their
 * own main with the Monitor, but we have to compile one with C++ rather
 * than use the one defined with the Encina Monitor library.
 *
 * monmain.C,v 1.5 1994/04/28 21:24:35 gjb Exp
 */



    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/

#include <monobjtran/monerror.H>
#include <objdce/statics.H>
#include <objdce/objtranparams.H>
#include <objdce/transignals.H>
#include <monobjtran/monserver.H>
#include <monobjtran/monclient.H>
#include <stdio.h>
#include <iostream.h>
extern "C"
{
#include <trpc/trpc.h>
}

static MonServer* theServer;
static MonOutput* o;

void MonPostInitCall(void*, unsigned long)

{
  o = new MonOutput;
  Boolean (*ptrChLvl)(ErrorLevels::ReportingLevels,
                      ErrorLevels::ReportingLevels);

  ObjtranReport.SetOutput(*o);
  ptrChLvl = &CheckLevelMon;
  ObjtranReport.SetCheckPtr(ptrChLvl);

  ObjtranMainMode = OBJTRAN_MONITOR_SERVER;
  trpc_outOfBandMode = TRPC_SERIAL_RPCS;
  theServer->RegisterTRPCCallbacks();
  theServer->PostInit();
}

void server_Init(int argc, char** argv)

{
  theServer->CatchSignal(SIGUSR1, *theServer);
  theServer->Init(argc, argv);
  mon_CallAfterInitComplete(MonPostInitCall, (void*)0, 0);
}

void server_Terminate()

{
  theServer->Terminate();
  ObjtranMainMode = 0;
}

int main (int argc, char** argv)

{
  trpc_outOfBandMode = TRPC_SERIAL_RPCS;
  theServer = new MonServer();
  mon_Main(argc, argv, server_Init, server_Terminate);
  delete theServer;
  delete(o);
  return 0;
}
