/*
 * MonServer
 *    Here we set things up so the user has to do very little to initalize
 * and shut down a monitor server.
 * 
 * monserver.C,v 1.4 1994/03/09 15:13:03 alina Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#include <monobjtran/monserver.H>
#include <monobjtran/monerror.H>
#include <objdce/error.H>
#include <objtran/rpctrancheckstatus.H>
#include <objtran/tranaux.H>
#include <objtran/transaction.H>
#include <objdce/objtranparams.H>
#include <Pool.h>
extern "C"
{
#include <trpc/trpc.h>
}

MonServer::MonServer() : MonAppl()

{
  encinaInitialized = true;
}

MonServer::~MonServer()

{
  encinaInitialized = false;
}

void MonServer::ChangeClassId(long id)
{
 MonOutput* o;
 o = new MonOutput(id); 
 Boolean (*ptrChLvl)(ErrorLevels::ReportingLevels,
                     ErrorLevels::ReportingLevels);

 ObjtranReport.SetOutput(*o);
 ptrChLvl = &CheckLevelMon;
 ObjtranReport.SetCheckPtr(ptrChLvl);
} 

void MonServer::ExportInterface(rpc_if_handle_t* ifh, rpc_mgr_epv_t* epv)

{
  mon_status_t err;

  ObjtranReport.ReportMsg(ErrorLevels::InfoMsg, 3011);
  err = mon_InitServerInterface(*ifh, *epv);
  CheckTranStatus(err, true, 3009, ErrorLevels::ErrorMsg);
}

void MonServer::MakeRecoverable()

{
  mon_status_t err;

  ObjtranReport.ReportMsg(ErrorLevels::InfoMsg, 3012);
  err = mon_ServerRecoverable();
  CheckTranStatus(err, true, 3011, ErrorLevels::ErrorMsg);
}

Signaled::SigStatus MonServer::HandleSignal(const int sig)

{
  Signaled::SigStatus retVal = Signaled::NOT_HANDLED;

  if (sig == SIGUSR1)
    {
      DumpStatistics();
      retVal = Signaled::HANDLED;
    }
  return retVal;
}


