/*
 * aclclient.H
 *
 * aclclient.H,v 1.11 1994/04/07 19:20:22 gjb Exp
 */


    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef ACL_CLIENT_H
#define ACL_CLIENT_H

extern "C"
{
#include <pthread.h>
#include <dce/rgynbase.h>
}

#ifdef DOS
#include <dce/seclgn.h>
#else
extern "C"
{
#include <dce/sec_login.h> //pc-dce different
}
#endif

extern "C"
{
#include <dce/keymgmt.h>
#include <dce/aclbase.h>
}
#include <String.h>
#include <Map.h>
#include <objdce/defs.H>
#include <objdce/aclcache.H>


class _EXPORT ACLclient
{
  friend class _EXPORT ACLCleanupThread;
public:
  ACLclient();
  ~ACLclient();
  Boolean IsAuthorized(const String& object, sec_id_pac_t* pac, 
		       const List<String>& perms);
  Boolean IsAuthorized(const String& object, sec_id_pac_t* pac, 
		       const String& perm);
private:
  static Map<ACLKey, ACLValue>* CachedACLMap;
  static MutexLock* ACLMapLatch;
  static ACLCleanupThread* CleaningThread;
};

#endif
