

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/



/*
 * errorLevels.H
 *
 *    This file defines constants to be used for error reporting levels.
 * These are used by the error reporting code in objdce/error.H.
 *
 * errorLevels.H,v 1.3 1993/12/02 14:51:54 lcp Exp
 */

#ifndef ERROR_LEVELS_H
#define ERROR_LEVELS_H

class _EXPORT ErrorLevels
    {
    public:
        //
	// In the enum ReportingLevels, the order is EXTREMELY IMPORTANT. 
        // That means, don't change it!!
	//
      enum ReportingLevels {TraceMsg = 1, InfoMsg = 2, WarnMsg = 3, 
			    ErrorMsg = 4, FatalMsg = 5, NoMsg = 6};
    };

/*
 * The following symbols are defined for backward compatibility. They
 * will go away in a future release.
 */

#define DebugMsg ErrorLevels::TraceMsg
#define LowMsg ErrorLevels::InfoMsg
#define MedMsg ErrorLevels::ErrorMsg
#define NormalMsg ErrorLevels::ErrorMsg
#define HighMsg ErrorLevels::ErrorMsg
#define ExtremeMsg ErrorLevels::FatalMsg

#endif
