/*
 * objtranparams.C
 *
 *    These are constants defined in objtranparams.H. The idea here is to
 * put the values of the constants here rather than copying them in to
 * each header file and thus statically into each .o file. Here, we can
 * also modify them without having to re-compile the whole world.
 *    At some point, the Objdce and Objtran constants must be separated.
 *
 * objtranparams.C,v 1.5 1993/12/02 14:52:22 lcp Exp
 */


    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#include <objtranparams.H>

const int DefaultACLCacheLife = 10;
const char* const DefaultTRPCDir = "/.:/encina/trpc";
const int TranTimeoutGranularity = 2;
const char* const NoAbortReasonText = "No abort reason set.";
const unsigned long DefaultLogBufLen = 4096;
const long DefaultMsg = 2;
const int EncinaID = -1;
const int ObjtranID = -2;
const int OBJTRAN_MONITOR_UP =      0x0001;
const int OBJTRAN_MONITOR_CLIENT =  0x0002;
const int OBJTRAN_MONITOR_SERVER =  0x0004;
const int OBJTRAN_TRAN_CLIENT =     0x0008;
const int OBJTRAN_TRAN_SERVER =     0x0010;
const int OBJTRAN_RECOVERABLE =     0x0020;
const int ABORT_REASON_NULL = 0xfffe;
const unsigned long DefaultEphemeralDelivery = 30;
const unsigned long DefaultEphemeralRequirement = 60;

#if defined(DOS)   
const char _far * const ObjtranMsgCat = "c:\\objtran\\objdce\\objtran.cat";
const char _far * const DCEMsgCat = "c:\\objtran\\objdce\\objdce.cat";
#else
const char* const ObjtranMsgCat = "objtran.cat";
const char* const DCEMsgCat = "objdce.cat";
#endif 

/*
 * There's a bug in the A.02 HP-UX C++ compiler. Defining this symbol
 * is part of the official work-around from HP.
 */

#ifdef __hpux
#include <setjmp.h>
jmp_buf * __EH_JMPBUF_TEMP;
#endif
