/*
 * statics.H:
 *
 *    This module takes care of the initialization of static objects. There
 * is one static AbortReason object, plus a few in the ErrorReport hierarchy.
 * We can also put other initialization code here that must be executed before
 * anything else happens.
 *    C++ is supposed to initialize global, static objects automatically, but
 * not all compilers handle this properly with shared libraries. Also, having
 * a manual mechanism for this will allow people to set up these objects from
 * a C environment, since the C compiler, when used to link with C++ code,
 * won't make the constructors go off. Finally, there are a few things, 
 * particularly with signal handling, that must happen before anything else
 * does.
 * 
 * statics.H,v 1.5 1993/12/02 14:52:40 lcp Exp
 */


    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef OBJTRAN_STATICS_H
#define OBJTRAN_STATICS_H

#ifdef __cplusplus
extern "C" void ObjtranFirstInit();
extern "C" void ObjtranAndCCFirstInit();
#else
extern "C" void ObjtranFirstInit();
extern "C" void ObjtranAndCCFirstInit();
#endif

#endif
