/*
 * InterfaceStats:
 *
 *    A class that contains information on how many RPC calls and network
 * packets came in and out of this server. It is used by the Binding and
 * GenericRPCServer classes. The two non-inline functions are implemented
 * in nontranserver.C for convenience.
 *
 * stats.H,v 1.4 1993/12/02 14:52:42 lcp Exp
 */


    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef INTERFACE_STATS_H
#define INTERFACE_STATS_H

extern "C"
{
#include <dce/rpc.h>
}

class _EXPORT InterfaceStats

{
public:
  InterfaceStats();
  InterfaceStats(const rpc_stats_vector_t*);
  InterfaceStats& operator = (const rpc_stats_vector_t*);
  long CallsIn() const;
  long CallsOut() const;
  long PacketsIn() const;
  long PacketsOut() const;
private:
  long callsIn;
  long callsOut;
  long packetsIn;
  long packetsOut;
};

inline long InterfaceStats::CallsIn() const

{ return callsIn; }

inline long InterfaceStats::CallsOut() const

{ return callsOut; }

inline long InterfaceStats::PacketsIn() const

{ return packetsIn; }

inline long InterfaceStats::PacketsOut() const

{ return packetsOut; }

#endif

