/*
 * tranmember.C,v 1.5 1993/12/02 18:58:03 lcp Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#include <objtran/tranmember.H>
#include <objtran/transaction.H>
#include <objdce/defs.H>

/*
 * Constants
 */

const unsigned int REGISTER_ABORT = 0x0001;
const unsigned int REGISTER_COMMIT = 0x0002;
const unsigned int REGISTER_FINISHED = 0x0004;
const unsigned int REGISTER_PREPARE = 0x0010;
const unsigned int REGISTER_AUTO_DELETE = 0x0020;
const unsigned int REGISTER_ALL = 0x001f;

/*
 * TransactionMember callbacks: All the callbacks in the base class are
 *    defined, but do nothing. Subclasses must redefine whichever functions
 *    they want to use.
 */

TransactionMember::TransactionMember()

{
  autoDelete = false;
}

TransactionMember::~TransactionMember()

{
}

void TransactionMember::AbortCallback(Transaction&)

{
}

void TransactionMember::CommitCallback(const Transaction&)

{
}

void TransactionMember::FinishedCallback(const Transaction&)

{
}

void TransactionMember::PrepareCallback(const Transaction&, Transaction&)

{
}

void TransactionMember::DeleteAfterFinish(Boolean on)

{
  autoDelete = on;
}



