/*
 * transerver.C,v 1.17 1994/03/17 18:45:35 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#include <objtran/transerver.H>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#if HAVE_SYSENT_H
#include <sysent.h>
#endif
#include <iostream.h>
extern "C"
{
#include <dce/rpcbase.h>
#include <dce/dce_error.h>
#include <tran/tran.h>
#include <trpc/trpc.h>
#include <threadTid/threadTid.h>
#include <admin/admin.h>
/** Not now
#include <admin/admin_gen.h>
#include <admin/admin_trace.h>
#include <admin/admin_tran.h>
***/
}
#include <objdce/statics.H>
#include <objtran/rpctrancheckstatus.H>
#include <objdce/thread.H>
#include <objdce/error.H>
#include <objtran/transaction.H>
#include <objdce/binding.H>
#include <objdce/defs.H>

/* Avoid including DCE exception handling header file */

extern "C" void trdce_ServerListen(unsigned32, unsigned32*);

/* This is because the "admin" .h files weren't generated from IDL right: */

// extern rpc_mgr_epv_t admin_gen_v1_0_mgr_epv;
// extern rpc_mgr_epv_t admin_tran_v1_0_mgr_epv;

static int AuthorizeEncinaAdmin(handle_t, char*)

{
  return 1;	// This is temporary
}

TranServer::TranServer(rpc_if_handle_t* ifh, 
		       rpc_mgr_epv_t* entryVector,  
		       const String& nsName,
		       ServerLoginContext* login,
		       List_of_p<TranComponent>* c) 
    : TranTRPCComponent(login), GenericRPCServer(), 
      Signaler(), Signaled()
{
  InterfaceSpec* interface;
  DCEuuid newUUID;
  unsigned long status;

  ObjtranFirstInit();
  if (ifh == nil)
    {
      ObjtranReport.ReportMsg(ErrorLevels::ErrorMsg, 1113);
      abort();
    }
  appl = new TranAppl(c, this);
  allowKeyboardSignals = true;
  SetHandler();
  protocol = ALL;
  loginContext = login;
  rpc_server_inq_bindings(&bVector, &status);
  ObjtranReport.Report(ErrorLevels::TraceMsg, "Calling ClearBinding\n");
  ClearBinding(nsName, ifh);
  interface = new InterfaceSpec(ifh, entryVector, nsName, "",
				(DCEuuid*)0, &newUUID);
  interface->RegisterHandle();
  interface->RegisterWithRPCD(bVector);
  interface->RegisterWithCDS(bVector);
  interfaces.put(interface);
  RegisterManagementAuthFunction();
/**** Put these back later
      admin_RegisterAuthorizationCallback(AuthorizeEncinaAdmin);
      RegisterAdminInterface(admin_gen_v1_0_s_ifspec, 
			     admin_gen_v1_0_mgr_epv, nsName, &newUUID,
			     "Encina general administrative interface", 
			     "admin_gen");
      RegisterAdminInterface(admin_tran_v1_0_s_ifspec, 
			     admin_tran_v1_0_mgr_epv, nsName, &newUUID,
			     "Encina TRAN administrative interface", 
			     "admin_tran");
*****/
  ObjtranMainMode = OBJTRAN_TRAN_SERVER;
}

TranServer::TranServer(rpc_if_handle_t* ifh, 
		       rpc_mgr_epv_t* entryVector,  
		       const String& nsName,
		       const String& annotation,
		       const RPCCommProtocol RPCprotocol,
		       ServerLoginContext* login,
		       List_of_p<TranComponent>* c,
		       DCEuuid* typeUUID,
		       DCEuuid* objUUID) 
    : GenericRPCServer(), TranTRPCComponent(login, 0, RPCprotocol),
      Signaler(), Signaled()
{
  InterfaceSpec* interface;
  unsigned long status;
  
  ObjtranFirstInit();
  if (ifh == nil)
    {
      ObjtranReport.ReportMsg(ErrorLevels::ErrorMsg, 1113);
      abort();
    }
  SetHandler();
  appl = new TranAppl(c, this);
  allowKeyboardSignals = true;
  protocol = RPCprotocol;
  loginContext = login;
  rpc_server_inq_bindings(&bVector, &status);
  ObjtranReport.Report(ErrorLevels::TraceMsg, "Calling ClearBinding\n");
  ClearBinding(nsName, ifh);
  interface = new InterfaceSpec(ifh, entryVector, nsName, annotation, 
				typeUUID, objUUID);
  interface->RegisterHandle();
  interface->RegisterWithRPCD(bVector);
  interface->RegisterWithCDS(bVector);
  interfaces.put(interface);
  RegisterManagementAuthFunction();
/**** Put these in another time ***
      admin_RegisterAuthorizationCallback(AuthorizeEncinaAdmin);
      RegisterAdminInterface(admin_gen_v1_0_s_ifspec, 
			     admin_gen_v1_0_mgr_epv, nsName, objUUID,
			     "Encina general administrative interface", 
			     "admin_gen");
      RegisterAdminInterface(admin_tran_v1_0_s_ifspec, 
			     admin_tran_v1_0_mgr_epv, nsName, objUUID,
			     "Encina TRAN administrative interface", 
			     "admin_tran");
*****/
  ObjtranMainMode = OBJTRAN_TRAN_SERVER;
}

TranServer::TranServer(rpc_if_handle_t* ifh, 
		       rpc_mgr_epv_t* entryVector,
		       ServerLoginContext* login,
		       const long wkEndpoint,
		       List_of_p<TranComponent>* c) 
    : GenericRPCServer(), TranTRPCComponent(login, wkEndpoint, UDP),
      Signaler(), Signaled()
{
  InterfaceSpec* interface;
  unsigned long status;

  ObjtranFirstInit();
  if (ifh == nil)
    {
      ObjtranReport.ReportMsg(ErrorLevels::ErrorMsg, 1113);
      abort();
    }
  SetHandler();
  appl = new TranAppl(c, this);
  allowKeyboardSignals = true;
  protocol = UDP;
  loginContext = login;
  rpc_server_inq_bindings(&bVector, &status);
  interface = new InterfaceSpec(ifh, entryVector, "", "", 
				(DCEuuid*)0, (DCEuuid*)0);
  interface->RegisterHandle();
  interfaces.put(interface);
  RegisterManagementAuthFunction();
  ObjtranMainMode = OBJTRAN_TRAN_SERVER;
}

TranServer::~TranServer()

{
  delete appl;
}

void TranServer::StartServer(const int numRpcThreads)

{
    unsigned32 err;
    unsigned char dceMsg[255];
    int errErr;
    String format;
    char tmpMsg[255];

    ObjtranReport.VReport(ErrorLevels::InfoMsg, "StartServer -- Number of Threads: %d\n", numRpcThreads);
    trdce_ServerListen(numRpcThreads, &err);
    if (err != rpc_s_ok)
    {
	dce_error_inq_text(err, dceMsg, &errErr);
	ObjtranReport.GetMsg(1110, format);	    // Error initing TRPC
#if HAVE_CMA_SPRINTF
	cma_sprintf(tmpMsg, (char*)((const char*)format), dceMsg);
#else
	sprintf(tmpMsg, format, dceMsg);
#endif
	ObjtranReport.Report(ErrorLevels::ErrorMsg, tmpMsg);
    }
}

void TranServer::RegisterAdminInterface(rpc_if_handle_t ifh,
					rpc_mgr_epv_t epv,
					const String& nsName, DCEuuid* uuid,
					const String& annot,
					const String& iName)
{
/***
  int didInit = 0;
  InterfaceSpec* adminInter;

  adminInter = new InterfaceSpec(&ifh, &epv, nsName, annot,
				 (DCEuuid*)0, uuid);
  admin_RegisterInterface(ifh, epv, (char*)((const char*)iName), &didInit);
  if (didInit)
    {
      adminInter->RegisterWithRPCD(bVector);
      adminInter->RegisterWithCDS(bVector);
      interfaces.put(adminInter);
      ObjtranReport.VReport(ErrorLevels::TraceMsg,
			    "\"%s\" administrative interface registered\n", (const char*)iName);
    }
  else
    ObjtranReport.VReportMsg(ErrorLevels::ErrorMsg, 1158, (const char*)iName);
  ***/
}

Boolean TranServer::IsClntAuthorized(trpc_handle_t handle,
				     const String& ACLkey, 
				     const List<String>& perms)
{
  rpc_binding_handle_t rpcHandle;
  trpc_GetRpcHandleFromBinding(handle, &rpcHandle);
  return GenericRPCServer::IsClntAuthorized(rpcHandle, ACLkey, perms);
}

Boolean TranServer::IsClntAuthorized(trpc_handle_t handle,
				     const String& ACLkey, 
				     const String& perms)
{
  rpc_binding_handle_t rpcHandle;
  trpc_GetRpcHandleFromBinding(handle, &rpcHandle);
  return GenericRPCServer::IsClntAuthorized(rpcHandle, ACLkey, perms);
}

Boolean TranServer::IsClntAuthorized(trpc_handle_t handle)
{
  rpc_binding_handle_t rpcHandle;
  trpc_GetRpcHandleFromBinding(handle, &rpcHandle);
  return GenericRPCServer::IsClntAuthorized(rpcHandle);
}

Boolean TranServer::IsClntAuthorized(handle_t handle,
				     const String& ACLkey, 
				     const List<String>& perms)
{
  return GenericRPCServer::IsClntAuthorized(handle, ACLkey, perms);
}

Boolean TranServer::IsClntAuthorized(handle_t handle,
				     const String& ACLkey, const String& perms)
{
  return GenericRPCServer::IsClntAuthorized(handle, ACLkey, perms);
}

Boolean TranServer::IsClntAuthorized(handle_t handle)
{
  return GenericRPCServer::IsClntAuthorized(handle);
}

void TranServer::SetHandler()

{
  ObjtranReport.Report(ErrorLevels::TraceMsg, 
		       "Calling CatchSignal for: SIGINT\n");
  CatchSignal(SIGINT, *this);
  ObjtranReport.Report(ErrorLevels::TraceMsg, 
		       "Calling CatchSignal for: SIGTERM\n");
  CatchSignal(SIGTERM, *this);
  ObjtranReport.Report(ErrorLevels::TraceMsg, 
		       "Calling CatchSignal for: SIGUSR1\n");
  CatchSignal(SIGUSR1, *this);
}

Signaled::SigStatus TranServer::HandleSignal(const int sig)

{
  Signaled::SigStatus retVal;
  
  switch(sig)
    {
    case SIGINT:
      ObjtranReport.Report(ErrorLevels::InfoMsg, "Received Signal: SIGINT in TranServer\n");
      if (allowKeyboardSignals)
	{
	  ObjtranReport.Report(ErrorLevels::InfoMsg, "Stopping Server\n");
	  StopServer();
	  retVal = Signaled::HANDLED;
	}
      else
	retVal = Signaled::HANDLED;
      break;
    case SIGTERM:
      ObjtranReport.Report(ErrorLevels::InfoMsg, "Received Signal: SIGTERM in TranServer\n");
      ObjtranReport.Report(ErrorLevels::InfoMsg, "Stopping Server\n");
      StopServer();
      retVal = Signaled::HANDLED;
      break;
    case SIGTSTP:
      ObjtranReport.Report(ErrorLevels::InfoMsg, "Received Signal: SIGTSTP in TranServer\n");
      if (allowKeyboardSignals)
	retVal = Signaled::NOT_HANDLED;
      else
	retVal = Signaled::HANDLED;
      break;
    case SIGUSR1:
      ObjtranReport.Report(ErrorLevels::InfoMsg, "Received Signal: SIGUSR1 in TranServer\n");
      ObjtranReport.Report(ErrorLevels::TraceMsg, "Dumping Statistics\n");
      DumpStatistics();
      retVal = Signaled::HANDLED;
      break;
    default:
      ObjtranReport.Report(ErrorLevels::InfoMsg, "Received Signal: Unknown in TranServer - Not Handled\n");
      retVal = Signaled::NOT_HANDLED;
      break;
    }
  return retVal;
}

/*
 * DisableKeyboardSignals
 *    Don't allow control-C to terminate anything
 */

void TranServer::DisableKeyboardSignals()

{
  ObjtranReport.Report(ErrorLevels::TraceMsg, "Disabling Keyboard Signals\n");
  ObjtranReport.Report(ErrorLevels::TraceMsg, 
		       "Calling CatchSignal for: SIGTSTP\n");
  CatchSignal(SIGTSTP, *this);
  allowKeyboardSignals = false;
}

/*
 * DontHandleSignals
 *    Disable signal handling -- if called, DisableKeyboardSignals will
 * also have no effect.
 */

void TranServer::DontHandleSignals()

{
  RemoveHandler(this);
}

