/*
 * acctblock.H
 *
 *    This class is a block of "accounts" I can use to pretend I'm
 * doing something transactional. What fun.
 *
 * acctblock.H,v 1.1 1993/05/24 18:16:15 gjb Exp
 */

#ifndef ACCT_BLOCK_H
#define ACCT_BLOCK_H

#include <String.h>
#include <Block.h>
#include <List.h>
#include <simpleacct.H>
#include <acctstatus.H>
#include <objtran/lock.H>
#include <objdce/mutex.H>

class AccountBlock

{
public:
  AccountBlock(AccountID low, AccountID high, double initBalance);
  AccountBlock(const AccountBlock&);
  ~AccountBlock();
  AcctStatus Lock(const AccountID, LockMode mode);
  AcctStatus Update(const AccountID, const double newBalance);
  AcctStatus Get(const AccountID key, SimpleAccount& out);
  AcctStatus Find(const String& name, List<AccountID>& out);
  AcctStatus Find(const double balance, Comparator, List<AccountID>& out);
  unsigned int Length() const;
private:
  void ThrowError(AcctStatus);
  Block<SimpleAccount> theData;	
  MutexLock blockLock;
  unsigned int numItems;
  AccountID base;
};

inline unsigned int AccountBlock::Length() const

{ return numItems; }

#endif
