/*
 * acltest.C
 *
 *    This is a little test of the ACLclient class. It's interactive
 * for now, although this may change in the future.
 *
 * acltest.C,v 1.2 1994/03/17 18:46:43 gjb Exp
 */

#include <objdce/statics.H>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <objdce/aclclient.H>
#include <Path.h>
#include <List.h>

ACLclient TheClient;

void DoChecks()

{
  char input[256];
  char command = '\0';
  String curBase = "/.:";
  String curObject;
  String curPerm;
  List<String> permList;
  Listiter<String> permListIter(permList);

  while (command != 'q')
    {
      printf("[ <L>ookup <M>ultiple lookup <C>hange base <Q>uit ] ");
      gets(input);
      command = input[0];
      tolower(command);
      switch(command)
	{
	case 'l':
	  curObject = curBase + "/";
	  printf("Lookup: %s", (const char*)curObject);
	  gets(input);
	  curObject += input;
	  printf("Permission: ");
	  gets(input);
	  curPerm = input;
	  if (TheClient.IsAuthorized(curObject, (sec_id_pac_t*)0, curPerm))
	    {
	      printf("Authorized.\n");
	    }
	  else
	    {
	      printf("Not authorized.\n");
	    }
	  break;
	case 'm':
	  curObject = curBase + "/";
	  printf("Lookup multiple: %s", (const char*)curObject);
	  gets(input);
	  curObject += input;
	  printf("Permission (Return to end): ");
	  gets(input);
	  curPerm = input;
	  while (curPerm.length() > 0)
	    {
	      permList.put(curPerm);
	      printf("Permission (Return to end): ");
	      gets(input);
	      curPerm = input;
	    }
	  if (TheClient.IsAuthorized(curObject, (sec_id_pac_t*)0,
				     permList))
	    {
	      printf("Authorized.\n");
	    }
	  else
	    {
	      printf("Not authorized.\n");
	    }
	  while (permListIter.remove_next());
	  break;
	case 'c':
	  printf("New base: ");
	  gets(input);
	  curBase = input;
	  break;
	case 'q':
	  break;
	default:
	  printf("Invalid command.\n");
	  break;
	}
    }
}

static void PrintUsage(char* execName)

{
  printf("Usage: %s\n", execName);
}

int main (int argc, char** argv)

{
  if (argc != 1)
    {
      PrintUsage(argv[0]);
      return 1;
    }
  DoChecks();
  return 0;
}
