/*
 * big_svr.C
 * 
 *    This is a server that returns lots of data from each RPC.
 *
 * big_svr.C,v 1.2 1993/08/06 22:05:25 gjb Exp
 */

#include <objdce/statics.H>
#include <stdlib.h>
#include <stdio.h>
#include <objdce/nontranserver.H>
#include <objdce/binding.H>
#include <objdce/error.H>
#include <objdce_common.H>
#include <String.h>
#include <rpc_big.h>

ServerLoginContext* bigContext;
NonTranServer* bigServer;

static void PrintUsage(char* execName)

{
  printf("Usage: %s <protection> <name> <principal> <keytable>\n", execName);
}

int main (int argc, char** argv)

{
  String protLevel;
  String serverName;
  String principal;
  String keytable;
  Boolean loginOK;

  if (argc != 5)
    {
      PrintUsage(argv[0]);
      return 1;
    }

  protLevel = argv[1];
  serverName = argv[2];
  principal = argv[3];
  keytable = argv[4];
  protLevel.upper();
  if (protLevel != "NONE")
    {
      int slashIndex = serverName.strrchr('/');
      String directory = serverName.chunk(0, slashIndex);
      printf("Using ACL: %s\n", (const char*)directory);
      bigContext = new ServerLoginContext();
      loginOK = ServerLogin(protLevel, principal, keytable, 
			    directory, *bigContext);
    }
  else
    {
      loginOK = true;
      bigContext = (ServerLoginContext*)0;
    }
  if (!loginOK)
    {
      fprintf(stderr, "Error: Login failed\n");
      return -1;
    }
  bigServer = new NonTranServer(RPCServer(RpcTestBig,1,0), serverName, 
			     "objtran test data server", UDP, bigContext);
  printf("Listening...\n");
  bigServer->StartServer(24);
  printf("Terminating...\n");
  delete bigServer;
  if (bigContext != (ServerLoginContext*)0)
    delete bigContext;
  return 0;
}

  

