/*
 * rpc_funcs.C
 *    Some accounting functions.
 *
 * rpc_funcs.C,v 1.2 1993/06/22 20:33:12 gjb Exp
 */

#include <rpc_funcs.H>
#include <iostream.h>
#include <objdce/dcetime.H>

static const double Nano = 1000000000.0;

/* Globals */

NonTranServer* server;
ServerLoginContext* context;
unsigned long SampleAddCalled;
unsigned long SampleStringCalled;
unsigned long SampleStructCalled;
unsigned long BroadcastCalled;
MutexLock CountLatch;
char* ACLDirectory;

void InitCounts()

{
  server = (NonTranServer*)0;
  context = (ServerLoginContext*)0;
  SampleAddCalled = 0;
  SampleStringCalled = 0;
  SampleStructCalled = 0;
  BroadcastCalled = 0;
}

void PrintClientCounts(const AbsoluteTime& startTime, 
		       const AbsoluteTime& stopTime)

{
  double rate;
  unsigned long rpcCount;
  RelativeTime elapsed;
  String elapsedStr;

  elapsed = stopTime - startTime;
  rpcCount = SampleAddCalled + SampleStringCalled + SampleStructCalled;
  rate = elapsed.CalculateRate(rpcCount);
  elapsed.GetTime(elapsedStr);

  cout.precision(3);
  cout << "Number of RPCs made or received:" << endl;
  cout << "SampleAdd:        " << SampleAddCalled << endl;
  cout << "SampleString:     " << SampleStringCalled << endl;
  cout << "SampleStruct:     " << SampleStructCalled << endl;
  cout << "BroadcastMessage: " << BroadcastCalled << endl;
  cout << endl;

  cout << "Elapsed time:     " << elapsedStr << " seconds" << endl;
  cout << "Rate:             " << rate << " RPCs/second" << endl;
}

void PrintCounts()

{
  cout << "Number of RPCs made or received:" << endl;
  cout << "SampleAdd:        " << SampleAddCalled << endl;
  cout << "SampleString:     " << SampleStringCalled << endl;
  cout << "SampleStruct:     " << SampleStructCalled << endl;
  cout << "BroadcastMessage: " << BroadcastCalled << endl;
}

