/*
 * rpc_two_funcs.C
 *
 *    These are the functions defined in the "RpcTestTwo" interface.
 *
 * rpc_two_funcs.C,v 1.2 1993/06/22 20:33:21 gjb Exp
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <rpc_two.h>
#include <objdce/nontranserver.H>
#include <objdce/login.H>
#include <rpc_funcs.H>

static const int AsyncSleepTime = 10;

error_status_t SampleStruct(handle_t handle, RpcTestStruct* record)

{
  char realACL[256];

  sprintf(realACL, "%s/Account_%li", ACLDirectory, record->account);
  if ((context != nil) && (!server->IsClntAuthorized(handle, realACL, "r")))
    return rpc_s_binding_has_no_auth;
  record->balance = record->balance * record->rate;
//  printf("Account %li: New balance: %.2f\n", record->account, 
//	 record->balance);
  CountLatch.Lock();
  SampleStructCalled++;
  CountLatch.Unlock();
  return 0;
}

void AsyncSample(handle_t, unsigned long count)

{
  printf("Processing async message %li\n", count);
  sleep(AsyncSleepTime);
  printf("Done with async message\n");
}
