/*
 * simple_svr.C
 *
 *    This is the first of the objdce test servers. This one just exports
 * the "rpc_one" IDL interface.
 *
 * simple_svr.C,v 1.4 1994/03/17 18:46:46 gjb Exp
 */

#include <objdce/statics.H>
#include <stdlib.h>
#include <stdio.h>
#include <objdce/nontranserver.H>
#include <objdce/binding.H>
#include <objdce/error.H>
#include <objdce_common.H>
#include <rpc_funcs.H>
#include <String.h>
#include <rpc_one.h>
#include <rpc_client.h>

static void PrintUsage()

{
  printf("Usage: simple_svr <protection> <name> <principal> <keytable>\n");
}

int main (int argc, char** argv)

{
  String protLevel;
  String serverName;
  String principal;
  String keytable;
  String tmpProt;
  Boolean loginOK;
  DCEuuid nullUUID = (uuid_t*)0;

  if (argc != 5)
    {
      PrintUsage();
      return 1;
    }
  InitCounts();
  tmpProt = argv[1];
  serverName = argv[2];
  principal = argv[3];
  keytable = argv[4];
  protLevel = tmpProt.upper();
  if (protLevel != "NONE")
    {
      int slashIndex = serverName.strrchr('/');
      String directory = serverName.chunk(0, slashIndex);
      printf("Using ACL: %s\n", (const char*)directory);
      context = new ServerLoginContext();
      loginOK = ServerLogin(protLevel, principal, keytable,
			    directory, *context);
    }
  else
    {
      loginOK = true;
      context = (ServerLoginContext*)0;
    }
  if (!loginOK)
    {
      fprintf(stderr, "Error: Login failed\n");
      return -1;
    }
//  server = new NonTranServer(RPCServer(RpcTestOne,1,0), serverName);
  server = new NonTranServer(RPCServer(RpcTestOne,1,0), serverName, 
			     "NULL UUID", ALL, context,
			     (rpc_mgr_epv_t*)0, (DCEuuid*)0, &nullUUID);
  server->AddInterface(RPCServer(RpcTestClient,1,0), serverName,
		       "Broadcast interface", (rpc_mgr_epv_t*)0,
		       (DCEuuid*)0, &nullUUID);
  printf("Listening...\n");
  server->StartServer(64);
  printf("Terminating...\n"); 
  delete server;
  if (context != (ServerLoginContext*)0)
    delete context;
  PrintCounts();

  printf("Sleeping for 20 seconds...\n");
  sleep(20);

  return 0;
}
