/*
 * simpleAcct.C
 *    This is a simple account record.
 */

#include <simpleacct.H>

SimpleAccount::SimpleAccount()  

{
  myID = NullAccountID;
  myBalance = 0.0;
}

SimpleAccount::SimpleAccount(const SimpleAccount& a)

{
  this->operator = (a);
}

SimpleAccount::SimpleAccount(const SimpleAccountData& d)

{
  this->operator = (d);
}

SimpleAccount::SimpleAccount(AccountID newID)

{
  myID = newID;
  myBalance = 0.0;
}

SimpleAccount::SimpleAccount(AccountID newID, const String& newName,
			     double newBalance)
{
  myID = newID;
  myName = newName;
  myBalance = newBalance;
}

SimpleAccount& SimpleAccount::operator = (const SimpleAccount& a)

{
  myID = a.myID;
  myName = a.myName;
  myBalance = a.myBalance;
  return *this;
}

SimpleAccount& SimpleAccount::operator = (const SimpleAccountData& d)

{
  myID = d.id;
  myName = (const char*)(d.name);
  myBalance = d.balance;
  return *this;
}

void SimpleAccount::Copy(SimpleAccountData& d)

{
  d.id = myID;
  strncpy((char*)(d.name), (const char*)myName, 128);
  d.name[128] = '\0';
  d.balance = myBalance;
}

void SimpleAccount::ID(const AccountID newID)

{
  myID = newID;
}

void SimpleAccount::Name(const String& newName)

{
  myName = newName;
}

void SimpleAccount::Balance(const double newBalance)

{
  myBalance = newBalance;
}


