/*
 * simpleacct.H
 * 
 *    This is one account for the database.
 */

#ifndef SIMPLE_ACCT_H
#define SIMPLE_ACCT_H

#include <String.h>
#include <accounts.h>

class SimpleAccount

{
public:
  SimpleAccount();
  SimpleAccount(const SimpleAccount&);
  SimpleAccount(const SimpleAccountData&);
  SimpleAccount(AccountID);
  SimpleAccount(AccountID, const String& name, double balance);
  ~SimpleAccount() {}
  SimpleAccount& operator = (const SimpleAccount&);
  SimpleAccount& operator = (const SimpleAccountData&);
  int operator == (const SimpleAccount&) const;
  int operator < (const SimpleAccount&) const;
  int operator > (const SimpleAccount&) const;
  void Copy(SimpleAccountData&);

  AccountID ID() const;
  void ID(const AccountID);
  const String& Name() const;
  String Name();
  void Name(const String&);
  double Balance() const;
  void Balance(const double);
private:
  AccountID myID;
  String myName;
  double myBalance;
};

inline AccountID SimpleAccount::ID() const

{ return myID; }

inline const String& SimpleAccount::Name() const

{ return myName; }

inline String SimpleAccount::Name()
     
{ return myName; }

inline double SimpleAccount::Balance() const

{ return myBalance; }

inline int SimpleAccount::operator == (const SimpleAccount& a) const

{ return (myID == a.myID); }

inline int SimpleAccount::operator < (const SimpleAccount& a) const

{ return (myID < a.myID); }

inline int SimpleAccount::operator > (const SimpleAccount& a) const

{ return (myID > a.myID); }

#endif
