/*
 * tran_one_funcs.C
 *
 *    These are the functions declared in the "TranTestOne" interface.
 * 
 * tran_one_funcs.C,v 1.3 1993/12/01 18:35:11 gjb Exp
 */

#include <stdio.h>
#include <objtran/transerver.H>
#include <objtran/transaction.H>
#include <objdce/abortreason.H>
#include <objdce/login.H>
#include <rpc_funcs.H>
#include <tran_funcs.H>
extern "C" 
{
#include <tran_one.h>
}

static void TranAddCleanup(void*)

{
  printf("TranAdd was cancelled in server thread\n");
}

void TranAdd(trpc_handle_t handle, long a, long b, long* result)

{
//  pthread_cleanup_push(TranAddCleanup, (void*)0);
  ExistingTransaction tran;

//  tran.RequireDistributedOutcome(false);
  if ((context != nil) && (!tServer->IsClntAuthorized(handle)))
    {
      tran.Abort("Client not authorized", rpc_s_binding_has_no_auth,
		 TranTestID);
      return;
    }
  *result = a + b;
  if ((a % 50) == 0)
    tran.Abort("User-requested abort", 1, TranTestID);
  if (!tran.Aborted())
    {
      CountLatch.Lock();
      SampleAddCalled++;
      CountLatch.Unlock();
    }
  else
    {
      String abortMsg;
      tran.GetAbortReason()->Print(abortMsg);
      printf("Aborted transaction: %s\n", (const char*)abortMsg);
    }
//  pthread_cleanup_pop(0);
}

static void TranStringCleanup(void*)

{
  printf("TranString was cancelled in server thread\n");
}

void TranString(trpc_handle_t handle, unsigned char*)

{
//  pthread_cleanup_push(TranStringCleanup, (void*)0);
  ExistingTransaction tran;

//  tran.RequireDistributedOutcome(false);
  if ((context != nil) && (!tServer->IsClntAuthorized(handle)))
    {
      tran.Abort("Client not authorized", rpc_s_binding_has_no_auth,
		 TranTestID);
      return;
    }
  CountLatch.Lock();
  SampleStringCalled++;
  CountLatch.Unlock();
//  pthread_cleanup_pop(0);
}

